using System.Xml;
using System.IO;
using System;

namespace Core.DBUtility
{
    /// <summary>
    /// ڻȡWeb.config/*.exe.configнڵݵĸ
    /// </summary>
    public sealed class AppConfig
    {
        private string filePath;

        /// <summary>
        /// ӵǰĿ¼а˳Web.Config*.App.Configļ
        /// ҵһʹΪļ׳һArgumentNullException쳣
        /// </summary>
        public AppConfig()
        {
            string webconfig = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "Web.Config");
            string appConfig = AppDomain.CurrentDomain.SetupInformation.ConfigurationFile.Replace(".vshost", "");

            if (File.Exists(webconfig))
            {
                filePath = webconfig;
            }
            else if (File.Exists(appConfig))
            {
                filePath = appConfig;
            }
            else
            {
                throw new ArgumentNullException("ûҵWeb.ConfigļӦóļ, ָļ");
            }
        }

        /// <summary>
        /// ûָļ·
        /// </summary>
        /// <param name="configFilePath">ļ··</param>
        public AppConfig(string configFilePath)
        {
            filePath = configFilePath;
        }

        /// <summary>
        /// óconfigļ
        /// </summary>
        /// <param name="keyName"></param>
        /// <param name="keyValue">ֵ</param>
        public void AppConfigSet(string keyName, string keyValue)
        {
            //ڴڶAddֵʹ÷appSettingĲɹע䣬µķʽ
            /* 
            string xpath = "//add[@key='" + keyName + "']";
            XmlDocument document = new XmlDocument();
            document.Load(filePath);

            XmlNode node = document.SelectSingleNode(xpath);
            node.Attributes["value"].Value = keyValue;
            document.Save(filePath); 
             */

            XmlDocument document = new XmlDocument();
            document.Load(filePath);

            XmlNodeList nodes = document.GetElementsByTagName("add");
            for (int i = 0; i < nodes.Count; i++)
            {
                //ýǰԪصkey
                XmlAttribute attribute = nodes[i].Attributes["key"];
                //ԪصĵһжϵǰԪǲĿԪ
                if (attribute != null && (attribute.Value == keyName))
                {
                    attribute = nodes[i].Attributes["value"];
                    //ĿԪеĵڶԸֵ
                    if (attribute != null)
                    {
                        attribute.Value = keyValue;
                        break;
                    }
                }
            }
            document.Save(filePath);
        }

        /// <summary>
        /// ȡconfigļļֵ
        /// ڣؿ
        /// </summary>
        /// <param name="keyName"></param>
        /// <returns></returns>
        public string AppConfigGet(string keyName)
        {
            string strReturn = string.Empty;
            try
            {
                XmlDocument document = new XmlDocument();
                document.Load(filePath);

                XmlNodeList nodes = document.GetElementsByTagName("add");
                for (int i = 0; i < nodes.Count; i++)
                {
                    //ýǰԪصkey
                    XmlAttribute attribute = nodes[i].Attributes["key"];
                    //ԪصĵһжϵǰԪǲĿԪ
                    if (attribute != null && (attribute.Value == keyName))
                    {
                        attribute = nodes[i].Attributes["value"];
                        if (attribute != null)
                        {
                            strReturn = attribute.Value;
                            break;
                        }
                    }
                }
            }
            catch
            {
                ;
            }

            return strReturn;
        }

        /// <summary>
        /// ȡָеֵ
        /// </summary>
        /// <param name="keyName"></param>
        /// <param name="subKeyName">Էֺ(;)Ϊָ</param>
        /// <returns>ӦƵֵ=źֵ</returns>
        public string GetSubValue(string keyName, string subKeyName)
        {
            string connectionString = AppConfigGet(keyName).ToLower();
            string[] item = connectionString.Split(new char[] { ';' });

            for (int i = 0; i < item.Length; i++)
            {
                string itemValue = item[i].ToLower();
                if (itemValue.IndexOf(subKeyName.ToLower()) >= 0) //ָĹؼ
                {
                    int startIndex = item[i].IndexOf("="); //Ⱥſʼλ
                    return item[i].Substring(startIndex + 1); //ȡȺźֵΪValue
                }
            }
            return string.Empty;
        }

        #region һЩõ

        /// <summary>
        /// ļȡȨϵͳӣHWSecurityֵ
        /// </summary>
        public string HWSecurity
        {
            get
            {
                return AppConfigGet("HWSecurity");
            }
        }

        /// <summary>
        /// ϵͳıʶIDSystem_IDֵ
        /// </summary>
        public string System_ID
        {
            get
            {
                return AppConfigGet("System_ID");
            }
        }

        /// <summary>
        /// ӦóƣApplicationNameֵ
        /// </summary>
        public string AppName
        {
            get
            {
                return AppConfigGet("ApplicationName");
            }
        }

        /// <summary>
        /// ƣManufacturerֵ
        /// </summary>
        public string Manufacturer
        {
            get
            {
                return AppConfigGet("Manufacturer");
            }
        }

        /// <summary>
        /// óconfigļEnterprise Libraryݿӵַ
        /// </summary>
        /// <param name="filePath">Web.config*.exe.configļľ·</param>
        /// <param name="keyName"></param>
        /// <param name="keyValue">ֵ</param>
        public void SetConnectionString(string keyName, string keyValue)
        {
            XmlDocument document = new XmlDocument();
            document.Load(filePath);

            XmlNodeList nodes = document.GetElementsByTagName("add");
            for (int i = 0; i < nodes.Count; i++)
            {
                //ýǰԪصname
                XmlAttribute att = nodes[i].Attributes["name"];
                //ԪصĵһжϵǰԪǲĿԪ
                if (att != null && (att.Value == keyName))
                {
                    att = nodes[i].Attributes["connectionString"];
                    if (att != null)
                    {
                        att.Value = keyValue;
                        break;
                    }
                }
            }
            document.Save(filePath);
        }

        /// <summary>
        /// ȡconfigļEnterprise Libraryݿӵַ
        /// </summary>
        /// <param name="filePath">Web.config*.exe.configļľ·</param>
        /// <param name="keyName"></param>
        /// <returns></returns>
        public string GetConnectionString(string keyName)
        {
            string strReturn = string.Empty;
            try
            {
                XmlDocument document = new XmlDocument();
                document.Load(filePath);

                XmlNodeList nodes = document.GetElementsByTagName("add");
                for (int i = 0; i < nodes.Count; i++)
                {
                    //ýǰԪصkey
                    XmlAttribute att = nodes[i].Attributes["name"];
                    //ԪصĵһжϵǰԪǲĿԪ
                    if (att != null && (att.Value == keyName))
                    {
                        att = nodes[i].Attributes["connectionString"];
                        if (att != null)
                        {
                            strReturn = att.Value;
                            break;
                        }
                    }
                }
            }
            catch
            { ; }

            return strReturn;
        }

        /// <summary>
        /// ȡݿϢ
        /// </summary>
        /// <param name="keyName">ڵ</param>
        /// <returns></returns>
        public DatabaseInfo GetDatabaseInfo(string keyName)
        {
            string connectionString = GetConnectionString(keyName);
            return new DatabaseInfo(connectionString);
        }

        /// <summary>
        /// ݿϢ
        /// </summary>
        /// <param name="keyName"></param>
        /// <param name="databaseInfo"></param>
        public void SetDatabaseInfo(string keyName, DatabaseInfo databaseInfo)
        {
            SetConnectionString(keyName, databaseInfo.ConnectionString);
        }

        #endregion
    }

}