using System.IO;

/// <summary>
/// GifʹõĿɱ䳤ȵLZWѹ㷨
/// </summary>
public class LZWDecoder
{
    #region 
    /// <summary>
    /// GIF涨Ϊ12bitֵΪ4096
    /// </summary>
    protected static readonly int MaxStackSize = 4096;
    protected Stream stream;
    #endregion

    #region 캯
    /// <summary>
    /// 캯
    /// </summary>
    public LZWDecoder(Stream stream)
    {
        this.stream = stream;
    }
    #endregion

    #region ˽з
    /// <summary>
    /// ȡݶ
    /// </summary>
    byte[] ReadData()
    {
        int blockSize = Read();
        return ReadByte(blockSize);
    }

    /// <summary>
    /// ȡָȵֽֽ
    /// </summary>
    byte[] ReadByte(int len)
    {
        byte[] buffer = new byte[len];
        stream.Read(buffer, 0, len);
        return buffer;
    }

    /// <summary>
    /// ȡһֽ
    /// </summary>
    int Read()
    {
        return stream.ReadByte();
    }
    #endregion

    #region ÷
    /// <summary>
    /// LZWѹ㷨
    /// </summary>
    /// <param name="width"></param>
    /// <param name="height">߶</param>
    /// <param name="stream"></param>
    /// <returns>ԭʼ</returns>
    public byte[] DecodeImageData(int width, int height, Stream stream)
    {
        int NullCode = -1;
        int pixelCount = width * height;//ȡԭͼʽΪ  = ͼ񳤶*ͼ߶
        byte[] pixels = new byte[pixelCount];
        int dataSize = Read();          //ͼĵһֽ(byte)ŵλСgifͨΪ1,4,8
        int codeSize = dataSize + 1;    //λСlzw㷨Ҫ󣬱λĴС = λС+1 gif¶Ӧϵ 1->3 4->5 ->9,codeSizeΪ12
        int clearFlag = 1 << dataSize;  //lzw㷨ǣclearFlagΪеǣ˺ı뽫ͷԷֹλ
        int endFlag = clearFlag + 1;    //lzw㷨֮һendFlagΪǣʾһαĽ  endFlag=clearFlag+1
        int available = endFlag + 1;    //ʼĿñСΪ0-(clear-1)ΪԪݣԾãо˴γѹı뿪ʼ

        int code = NullCode;     //ڴ洢ǰıֵ
        int old_code = NullCode; //ڴ洢һεıֵ
        int code_mask = (1 << codeSize) - 1;//ʾֵcodeSize=5,code_mask=31
        int bits = 0;//ڱݵıʽΪbyteʵʱʵʱλ洢ģ統codeSize=5ʱôʵ5bitݾӦÿԱʾһ룬ȡ1ֽھ͸3bit3bitں͵ڶֽڵĺbitϣٴγɱֵ

        int[] prefix = new int[MaxStackSize];          //ڱǰ׺ļ
        int[] suffix = new int[MaxStackSize];          //ڱ׺
        int[] pixelStatck = new int[MaxStackSize + 1]; //ʱ

        int top = 0;
        int count = 0; //ѭУÿλȡһıֽ飬ЩʱҪ1ֽcountǱʾҪֽĿ
        int bi = 0;    //countʾʣֽҪbiʾѾĸ
        int i = 0;     //iǰõ

        int data = 0;          //ʾǰݵֵ
        int first = 0;         //һַصĵһֽ
        int inCode = NullCode; //lzwУʶһentry򽫱Ϊһεprefix˴inCodeݸһΪǰ׺ıֵ

        //Ԫݵǰ׺Ϻͺ׺ϣԪݵǰ׺Ϊ0׺ԪȣͬʱҲԪ
        for (code = 0; code < clearFlag; code++)
        {
            //ǰ׺ʼΪ0
            prefix[code] = 0;
            //׺=Ԫ=
            suffix[code] = (byte)code;
        }

        byte[] buffer = null;
        while (i < pixelCount)
        {
            //ѾȷΪpixelCount = width * width
            if (top == 0)
            {
                if (bits < codeSize)
                {
                    //ǰҪbitСڱλСҪ
                    if (count == 0)
                    {
                        //countΪ0ʾҪӱжһݶз
                        buffer = ReadData();
                        count = buffer.Length;
                        if (count == 0)
                        {
                            //ٴȡݶΣȴûжݣʱͱѾ
                            break;
                        }
                        //¶ȡһݶκӦýѾĸ0
                        bi = 0;
                    }
                    //ȡҪݵֵ
                    data += buffer[bi] << bits;//˴ΪҪλأһδ1ֽΪ176һֻҪ5bit͹ˣʣ3bit¸ֽڽϡҲǵڶֽڵĺλ+һֽڵǰλɵڶֵ
                    bits += 8; //ִһֽڣҪ+8
                    bi++;      //һֽ
                    count--;   //Ѿֽ+1
                    continue;
                }

                //Ѿ㹻bitɹǴ
                code = data & code_mask; //ȡdataݵıλСbit
                data >>= codeSize;       //ݽȡԭݾʣ¼bitˣʱЩbitƣΪ´׼
                bits -= codeSize;        //ͬʱҪǰݵbitȥλΪѾõ˴

                //ݻȡcodeֵд
                if (code > available || code == endFlag)
                {
                    //ֵֵΪǵʱֹͣ
                    break;
                }
                if (code == clearFlag)
                {
                    //ǰǣ³ʼ
                    codeSize = dataSize + 1;
                    //³ʼֵ
                    code_mask = (1 << codeSize) - 1;
                    //ʼһӦôñֵ
                    available = clearFlag + 2;
                    //浽old_codeеֵԱͷ
                    old_code = NullCode;
                    continue;
                }

                //codeѹı뷶ΧڵĵĴ
                if (old_code == NullCode)
                {
                    //ǰֵΪ,ʾǵһλȡ
                    pixelStatck[top++] = suffix[code];//ȡ1
                    //α봦ɣֵ浽old_code
                    old_code = code;
                    //һַΪǰ
                    first = code;
                    continue;
                }
                inCode = code;
                if (code == available)
                {
                    //ǰͱӦɵıͬ
                    pixelStatck[top++] = (byte)first;//ôһֽھ͵ڵǰַĵһֽ
                    code = old_code; //ݵһ
                }
                while (code > clearFlag)
                {
                    //ǰǣʾֵѹݵ
                    pixelStatck[top++] = suffix[code];
                    code = prefix[code];//ݵһ
                }
                first = suffix[code];
                if (available > MaxStackSize)
                {
                    //ֵgifı루4096ֵʱֹͣ
                    break;
                }

                //ȡһ
                pixelStatck[top++] = suffix[code];
                //õǰӦñλõǰ׺
                prefix[available] = old_code;
                //õǰӦñλõĺ׺
                suffix[available] = first;
                //´Ӧõõıֵ
                available++;
                if (available == code_mask + 1 && available < MaxStackSize)
                {
                    //ӱλ
                    codeSize++;
                    //ֵ
                    code_mask = (1 << codeSize) - 1;
                }
                //ԭold_code
                old_code = inCode;
            }
            //ݵһλ
            top--;
            //ȡԪ
            pixels[i++] = (byte)pixelStatck[top];
        }
        return pixels;
    }
    #endregion
}

//LZWѹ㷨ԭhttp://www.cnblogs.com/jillzhang/archive/2006/11/06/551298.html