using System;
using System.Web;



public class RequestHelp
{
    /// <summary>
    /// жϵǰҳǷյPost
    /// </summary>
    /// <returns>ǷյPost</returns>
    public static bool IsPost()
    {
        return HttpContext.Current.Request.HttpMethod.Equals("POST");
    }
    /// <summary>
    /// жϵǰҳǷյGet
    /// </summary>
    /// <returns>ǷյGet</returns>
    public static bool IsGet()
    {
        return HttpContext.Current.Request.HttpMethod.Equals("GET");
    }

    /// <summary>
    /// ָķϢ
    /// </summary>
    /// <param name="strName"></param>
    /// <returns>Ϣ</returns>
    public static string GetServerString(string strName)
    {
        //
        if (HttpContext.Current.Request.ServerVariables[strName] == null)
        {
            return "";
        }
        return HttpContext.Current.Request.ServerVariables[strName].ToString();
    }

    /// <summary>
    /// һҳĵַ
    /// </summary>
    /// <returns>һҳĵַ</returns>
    public static string GetUrlReferrer()
    {
        string retVal = null;

        try
        {
            retVal = HttpContext.Current.Request.UrlReferrer.ToString();
        }
        catch { }

        if (retVal == null)
            return "";

        return retVal;

    }

    /// <summary>
    /// õǰͷ
    /// </summary>
    /// <returns></returns>
    public static string GetCurrentFullHost()
    {
        HttpRequest request = System.Web.HttpContext.Current.Request;
        if (!request.Url.IsDefaultPort)
        {
            return string.Format("{0}:{1}", request.Url.Host, request.Url.Port.ToString());
        }
        return request.Url.Host;
    }

    /// <summary>
    /// õͷ
    /// </summary>
    /// <returns></returns>
    public static string GetHost()
    {
        return HttpContext.Current.Request.Url.Host;
    }


    /// <summary>
    /// ȡǰԭʼ URL(URL Ϣ֮Ĳ,ѯַ())
    /// </summary>
    /// <returns>ԭʼ URL</returns>
    public static string GetRawUrl()
    {
        return HttpContext.Current.Request.RawUrl;
    }

    /// <summary>
    /// жϵǰǷ
    /// </summary>
    /// <returns>ǰǷ</returns>
    public static bool IsBrowserGet()
    {
        string[] BrowserName = { "ie", "opera", "netscape", "mozilla", "konqueror", "firefox" };
        string curBrowser = HttpContext.Current.Request.Browser.Type.ToLower();
        for (int i = 0; i < BrowserName.Length; i++)
        {
            if (curBrowser.IndexOf(BrowserName[i]) >= 0)
            {
                return true;
            }
        }
        return false;
    }

    /// <summary>
    /// صǰҳǷǿվύ
    /// </summary>
    /// <returns>ǰҳǷǿվύ</returns>
    public static bool IsCrossSitePost()
    {

        // ύΪtrue
        if (!RequestHelp.IsPost())
        {
            return true;
        }
        return IsCrossSitePost(RequestHelp.GetUrlReferrer(), RequestHelp.GetHost());
    }

    /// <summary>
    /// жǷǿվύ
    /// </summary>
    /// <param name="urlReferrer">ϸҳַ</param>
    /// <param name="host">̳url</param>
    /// <returns></returns>
    public static bool IsCrossSitePost(string urlReferrer, string host)
    {
        if (urlReferrer.Length < 7)
        {
            return true;
        }
        Uri u = new Uri(urlReferrer);
        return u.Host != host;
    }

    /// <summary>
    /// жǷ
    /// </summary>
    /// <returns>Ƿ</returns>
    public static bool IsSearchEnginesGet()
    {
        if (HttpContext.Current.Request.UrlReferrer == null)
        {
            return false;
        }
        string[] SearchEngine = { "google", "yahoo", "msn", "baidu", "sogou", "sohu", "sina", "163", "lycos", "tom", "yisou", "iask", "soso", "gougou", "zhongsou" };
        string tmpReferrer = HttpContext.Current.Request.UrlReferrer.ToString().ToLower();
        for (int i = 0; i < SearchEngine.Length; i++)
        {
            if (tmpReferrer.IndexOf(SearchEngine[i]) >= 0)
            {
                return true;
            }
        }
        return false;
    }

    /// <summary>
    /// õǰUrlַ
    /// </summary>
    /// <returns>ǰUrlַ</returns>
    public static string GetUrl()
    {
        return HttpContext.Current.Request.Url.ToString();
    }


    /// <summary>
    /// ָUrlֵ
    /// </summary>
    /// <param name="strName">Url</param>
    /// <returns>Urlֵ</returns>
    public static string GetQueryString(string strName)
    {

        if (HttpContext.Current.Request.QueryString[strName] == null)
        {
            return String.Empty;
        }
        return HttpContext.Current.Request.QueryString[strName];

    }
    /// <summary>
    /// õǰҳ
    /// </summary>
    /// <returns>ǰҳ</returns>
    public static string GetPageName()
    {
        string[] urlArr = HttpContext.Current.Request.Url.AbsolutePath.Split('/');
        return urlArr[urlArr.Length - 1].ToLower();
    }

    /// <summary>
    /// رUrlܸ
    /// </summary>
    /// <returns></returns>
    public static int GetParamCount()
    {
        return HttpContext.Current.Request.Form.Count + HttpContext.Current.Request.QueryString.Count;
    }


    /// <summary>
    /// ֵָ
    /// </summary>
    /// <param name="strName"></param>
    /// <returns>ֵ</returns>
    public static string GetFormString(string strName)
    {
        if (HttpContext.Current.Request.Form[strName] == null)
        {
            return "";
        }
        return HttpContext.Current.Request.Form[strName];
    }

    /// <summary>
    /// Urlֵ, жUrlǷΪַ, ΪTrue򷵻رֵ
    /// </summary>
    /// <param name="strName"></param>
    /// <returns>Urlֵ</returns>
    public static string GetString(string strName)
    {
        if ("".Equals(GetQueryString(strName)))
        {
            return GetFormString(strName);
        }
        else
        {
            return GetQueryString(strName);
        }
    }



}

