using System;
using System.Drawing;
using System.IO;
using System.Runtime.InteropServices;
using System.Security;
using System.Text;


namespace DotNet.Utilities
{
    /// <summary>
    /// ִҪ <b>Win32</b> API Ĳࡣ
    /// </summary>
    [SuppressUnmanagedCodeSecurity()]
    public static partial class Win32
    {
        #region 

        /// <summary>
        /// ִлȡǰеĲϵͳ汾
        /// </summary>
        /// <returns><see cref="Platform"/> ֵ֮һʾǰеĲϵͳ汾</returns>
        private static Platform GetCurrentPlatform()
        {
            OperatingSystem os = Environment.OSVersion;
            Platform pt;
            switch(os.Platform)
            {
                case (PlatformID.Win32Windows): // Win95, Win98 or Me
                    switch(os.Version.Minor)
                    {
                        case (0): // 95
                            pt = Platform.Windows95;
                            break;
                        case (10): // 98
                            if(os.Version.Revision.ToString() == "2222A")
                                pt = Platform.Windows982ndEdition;
                            else
                                pt = Platform.Windows98;
                            break;
                        case (90): // winme
                            pt = Platform.WindowsME;
                            break;
                        default: // Unknown
                            pt = Platform.UnKnown;
                            break;
                    }
                    break;
                case (PlatformID.Win32NT): //Win2k or Xp or 2003
                    switch(os.Version.Major)
                    {
                        case (3):
                            pt = Platform.WindowsNT351;
                            break;
                        case (4):
                            pt = Platform.WindowsNT40;
                            break;
                        case (5):
                            if(os.Version.Minor == 0)
                                pt = Platform.Windows2000;
                            else if(os.Version.Minor == 1)
                                pt = Platform.WindowsXP;
                            else if(os.Version.Minor == 2)
                                pt = Platform.Windows2003;
                            else
                                pt = Platform.UnKnown;
                            break;
                        case (6):
                            pt = Platform.WindowsVista;
                            break;
                        default:
                            pt = Platform.UnKnown;
                            break;
                    }
                    break;
                case (PlatformID.WinCE): // WinCE
                    pt = Platform.WindowsCE;
                    break;
                case (PlatformID.Win32S):
                case (PlatformID.Unix):
                default:
                    pt = Platform.UnKnown;
                    break;
            }
            return pt;
        }

        /// <summary>
        /// ʾϵͳƽ̨
        /// </summary>
        private enum Platform : byte
        {
            /// <summary>
            /// Windows 95 ϵͳ.
            /// </summary>
            Windows95,
            /// <summary>
            /// Windows 98 ϵͳ.
            /// </summary>
            Windows98,
            /// <summary>
            /// Windows 98 ڶϵͳ.
            /// </summary>
            Windows982ndEdition,
            /// <summary>
            /// Windows ME ϵͳ.
            /// </summary>
            WindowsME,
            /// <summary>
            /// Windows NT 3.51 ϵͳ.
            /// </summary>
            WindowsNT351,
            /// <summary>
            /// Windows NT 4.0 ϵͳ.
            /// </summary>
            WindowsNT40,
            /// <summary>
            /// Windows 2000 ϵͳ.
            /// </summary>
            Windows2000,
            /// <summary>
            /// Windows XP ϵͳ.
            /// </summary>
            WindowsXP,
            /// <summary>
            /// Windows 2003 ϵͳ.
            /// </summary>
            Windows2003,
            /// <summary>
            /// Windows Vista ϵͳ.
            /// </summary>
            WindowsVista,
            /// <summary>
            /// Windows CE ϵͳ.
            /// </summary>
            WindowsCE,
            /// <summary>
            /// ϵͳ汾δ֪
            /// </summary>
            UnKnown
        }

        /// <summary>
        /// ʾIDE豸״̬ĳֵĶӦ
        /// </summary>
        /// <remarks>ֵ볣 <b>WinIoCtl.h</b> ļС</remarks>
        private enum DriverError : byte
        {
            /// <summary>
            /// 豸޴
            /// </summary>
            SMART_NO_ERROR = 0, // No error
            /// <summary>
            /// 豸IDE
            /// </summary>
            SMART_IDE_ERROR = 1, // Error from IDE controller
            /// <summary>
            /// Чǡ
            /// </summary>
            SMART_INVALID_FLAG = 2, // Invalid command flag
            /// <summary>
            /// Чݡ
            /// </summary>
            SMART_INVALID_COMMAND = 3, // Invalid command byte
            /// <summary>
            /// Ч绺Ϊջַ󣩡
            /// </summary>
            SMART_INVALID_BUFFER = 4, // Bad buffer (null, invalid addr..)
            /// <summary>
            /// 豸Ŵ
            /// </summary>
            SMART_INVALID_DRIVE = 5, // Drive number not valid
            /// <summary>
            /// IOCTL
            /// </summary>
            SMART_INVALID_IOCTL = 6, // Invalid IOCTL
            /// <summary>
            /// ޷ûĻ
            /// </summary>
            SMART_ERROR_NO_MEM = 7, // Could not lock user's buffer
            /// <summary>
            /// ЧIDEע
            /// </summary>
            SMART_INVALID_REGISTER = 8, // Some IDE Register not valid
            /// <summary>
            /// Чá
            /// </summary>
            SMART_NOT_SUPPORTED = 9, // Invalid cmd flag set
            /// <summary>
            /// ָҪҵЧ
            /// </summary>
            SMART_NO_IDE_DEVICE = 10
        }

        public static void ChangeByteOrder(byte[] charArray)
        {
            byte temp;
            for(int i = 0; i < charArray.Length; i += 2)
            {
                temp = charArray[i];
                charArray[i] = charArray[i + 1];
                charArray[i + 1] = temp;
            }
        }

        /// <summary>
        /// ָ豸Ϣ豸ϸϢ
        /// </summary>
        /// <param name="phdinfo">һ <see cref="IdSector"/></param>
        /// <returns></returns>
        private static HDiskInfo GetHardDiskInfo(IdSector phdinfo)
        {
            HDiskInfo hdd = new HDiskInfo();
            hdd.ModuleNumber = Encoding.ASCII.GetString(phdinfo.sModelNumber).Trim();
            hdd.Firmware = Encoding.ASCII.GetString(phdinfo.sFirmwareRev).Trim();
            hdd.SerialNumber = Encoding.ASCII.GetString(phdinfo.sSerialNumber).Trim();
            hdd.Capacity = phdinfo.ulTotalAddressableSectors / 2 / 1024;
            hdd.BufferSize = phdinfo.wBufferSize / 1024;
            return hdd;
        }

        /// <summary>
        /// ȡNTƽָ̨кŵӲϢ
        /// </summary>
        /// <param name="driveIndex">̵</param>
        /// <returns></returns>
        private static HDiskInfo GetHddInfoNT(byte driveIndex)
        {
            GetVersionOutParams vers = new GetVersionOutParams();
            SendCmdInParams inParam = new SendCmdInParams();
            SendCmdOutParams outParam = new SendCmdOutParams();
            uint bytesReturned = 0;

            // ʹ Win2000  XpµķȡӲϢ

            // ȡ豸ľ
            IntPtr hDevice =
                CreateFile(string.Format(@"\\.\PhysicalDrive{0}", driveIndex), GENERIC_READ | GENERIC_WRITE,
                           FILE_SHARE_READ | FILE_SHARE_WRITE, IntPtr.Zero, OPEN_EXISTING, 0, IntPtr.Zero);

            // ʼ
            if(hDevice == IntPtr.Zero)
                throw new UnauthorizedAccessException("ִ Win32 API  CreateFile ʧܡ");
            if(0 == DeviceIoControl(hDevice, SMART_GET_VERSION, IntPtr.Zero, 0, ref vers,
                (uint)Marshal.SizeOf(vers),
                ref bytesReturned,
                IntPtr.Zero))
            {
                CloseHandle(hDevice);
                throw new IOException(string.Format(ResourcesApi.Win32_DeviceIoControlErr, "SMART_GET_VERSION"));
            }
            // IDEǷ֧
            if(0 == (vers.fCapabilities & 1))
            {
                CloseHandle(hDevice);
                throw new IOException(ResourcesApi.Win32_DeviceIoControlNotSupport);
            }
            // Identify the IDE drives
            if(0 != (driveIndex & 1))
                inParam.irDriveRegs.bDriveHeadReg = 0xb0;
            else
                inParam.irDriveRegs.bDriveHeadReg = 0xa0;
            if(0 != (vers.fCapabilities & (16 >> driveIndex)))
            {
                // We don't detect a ATAPI device.
                CloseHandle(hDevice);
                throw new IOException(ResourcesApi.Win32_DeviceIoControlNotSupport);
            }
            else
                inParam.irDriveRegs.bCommandReg = 0xec;
            inParam.bDriveNumber = driveIndex;
            inParam.irDriveRegs.bSectorCountReg = 1;
            inParam.irDriveRegs.bSectorNumberReg = 1;
            inParam.cBufferSize = 512;

            if(0 == DeviceIoControl(
                hDevice,
                SMART_RCV_DRIVE_DATA,
                ref inParam,
                (uint)Marshal.SizeOf(inParam),
                ref outParam,
                (uint)Marshal.SizeOf(outParam),
                ref bytesReturned,
                IntPtr.Zero))
            {
                CloseHandle(hDevice);
                throw new IOException(
                        string.Format(ResourcesApi.Win32_DeviceIoControlErr, "SMART_RCV_DRIVE_DATA"));
            }
            CloseHandle(hDevice);
            ChangeByteOrder(outParam.bBuffer.sModelNumber);
            ChangeByteOrder(outParam.bBuffer.sSerialNumber);
            ChangeByteOrder(outParam.bBuffer.sFirmwareRev);
            return GetHardDiskInfo(outParam.bBuffer);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="driveIndex"></param>
        /// <returns></returns>
        private static HDiskInfo GetHddInfo9X(byte driveIndex)
        {
            GetVersionOutParams vers = new GetVersionOutParams();
            SendCmdInParams inParam = new SendCmdInParams();
            SendCmdOutParams outParam = new SendCmdOutParams();
            uint bytesReturned = 0;
            IntPtr hDevice = CreateFile(@"\\.\Smartvsd", 0, 0, IntPtr.Zero, CREATE_NEW, 0, IntPtr.Zero);
            if(hDevice == IntPtr.Zero)
                throw new UnauthorizedAccessException(" smartvsd.vxd ļʧܡ");
            if(0 == DeviceIoControl(hDevice, SMART_GET_VERSION, 
                IntPtr.Zero, 0, 
                ref vers, (uint)Marshal.SizeOf(vers), ref bytesReturned, IntPtr.Zero))
            {
                CloseHandle(hDevice);
                throw new IOException(string.Format(ResourcesApi.Win32_DeviceIoControlErr, "SMART_GET_VERSION"));
            }
            //  IDE ļʶʧ
            if(0 == (vers.fCapabilities & 1))
            {
                CloseHandle(hDevice);
                throw new IOException(ResourcesApi.Win32_DeviceIoControlNotSupport);
            }
            if(0 != (driveIndex & 1))
                inParam.irDriveRegs.bDriveHeadReg = 0xb0;
            else
                inParam.irDriveRegs.bDriveHeadReg = 0xa0;
            if(0 != (vers.fCapabilities & (16 >> driveIndex)))
            {
                // IDEΪATAPIͣ޷
                CloseHandle(hDevice);
                throw new IOException(ResourcesApi.Win32_DeviceIoControlNotSupport);
            }
            else
                inParam.irDriveRegs.bCommandReg = 0xec;
            inParam.bDriveNumber = driveIndex;
            inParam.irDriveRegs.bSectorCountReg = 1;
            inParam.irDriveRegs.bSectorNumberReg = 1;
            inParam.cBufferSize = BUFFER_SIZE;
            if(0 == DeviceIoControl(hDevice, SMART_RCV_DRIVE_DATA, ref inParam, (uint)Marshal.SizeOf(inParam), ref outParam, (uint)Marshal.SizeOf(outParam), ref bytesReturned, IntPtr.Zero))
            {
                CloseHandle(hDevice);
                throw new IOException(string.Format(ResourcesApi.Win32_DeviceIoControlErr, "SMART_RCV_DRIVE_DATA"));
            }
            // رļ
            CloseHandle(hDevice);
            ChangeByteOrder(outParam.bBuffer.sModelNumber);
            ChangeByteOrder(outParam.bBuffer.sSerialNumber);
            ChangeByteOrder(outParam.bBuffer.sFirmwareRev);
            return GetHardDiskInfo(outParam.bBuffer);
        }

        #endregion

        #region Win32

        /// <summary>
        /// ȡָڵϵͳ˵ľ
        /// </summary>
        /// <param name="hwnd">ָҪȡϵͳ˵ڵ <see cref="IntPtr"/> </param>
        /// <param name="bRevert">ȡϵͳ˵ķʽΪ <b>true</b>ʾԭʼϵͳ˵Ϊ <b>false</b> </param>
        /// <returns>ָҪȡϵͳ˵ <see cref="IntPtr"/> </returns>
        [DllImport("user32.dll", SetLastError = true)]
        private static extern IntPtr GetSystemMenu(IntPtr hwnd, bool bRevert);

        /// <summary>
        /// ȡָĲ˵Ŀ˵
        /// </summary>
        /// <param name="hMenu">ָҪȡ˵ϵͳ˵ <see cref="IntPtr"/> </param>
        /// <returns>˵еĿ</returns>
        [DllImport("user32.dll", SetLastError = true)]
        private static extern int GetMenuItemCount(IntPtr hMenu);

        /// <summary>
        /// ɾָĲ˵Ŀ
        /// </summary>
        /// <param name="hMenu">ָҪƳĲ˵ <see cref="IntPtr"/> </param>
        /// <param name="uPosition">ıĲ˵Ŀıʶ</param>
        /// <param name="uFlags"></param>
        /// <returns>ʾɹʾʧܡ</returns>
        /// <remarks>
        ///  <paramref name="uFlags"/> ʹ<see cref="MF_BYPOSITION"/>  <paramref name="uPosition"/> ʾ˵
        ///  <paramref name="uFlags"/> ʹ <b>MF_BYCOMMAND</b> <paramref name="uPosition"/> ʹò˵ID
        /// </remarks>
        [DllImport("user32.dll", SetLastError = true)]
        private static extern int RemoveMenu(IntPtr hMenu, int uPosition, int uFlags);

        /// <summary>
        /// رһָָָ豸
        /// </summary>
        /// <param name="hObject">Ҫرյľ <see cref="IntPtr"/> </param>
        /// <returns>ɹ <b>0</b> ɹطֵ</returns>
        [DllImport("kernel32.dll", SetLastError = true)]
        private static extern int CloseHandle(IntPtr hObject);

        /// <summary>
        /// ִд/ԴĹܡ
        /// </summary>
        /// <param name="lpFileName">ָҪ򿪵豸ļơ</param>
        /// <param name="dwDesiredAccess">
        /// <para>Win32 ڿƶ豸Ķʡдʻ/дʵĳ±
        /// <p><list type="table">
        /// <listheader>
        /// <term></term>
        /// <description>˵</description>
        /// </listheader>
        /// <item>
        /// <term>GENERIC_READ</term><description>ָ豸жȡʡ</description>
        /// </item>
        /// <item>
        /// <term>GENERIC_WRITE</term><description>ָ豸дʡ</description>
        /// </item>
        /// <item><term><b>0</b></term><description>ֵΪ㣬ʾֻȡһ豸йصϢ</description></item>
        /// </list></p>
        /// </para>
        /// </param>
        /// <param name="dwShareMode">ָ豸ʱļģʽ</param>
        /// <param name="lpSecurityAttributes"></param>
        /// <param name="dwCreationDisposition">Win32 ָϵͳļķʽ±
        /// <para><p>
        /// <list type="table">
        /// <listheader><term></term><description>˵</description></listheader>
        /// <item>
        /// <term>CREATE_NEW</term>
        /// <description>ָϵͳӦļļڣ׳ <see cref="IOException"/> 쳣</description>
        /// </item>
        /// <item><term>CREATE_ALWAYS</term><description>ָϵͳӦļļѴڣд</description></item>
        /// </list>
        /// </p></para>
        /// </param>
        /// <param name="dwFlagsAndAttributes"></param>
        /// <param name="hTemplateFile"></param>
        /// <returns>ʹú򿪵豸ľ</returns>
        /// <remarks>
        /// ִд򿪻ļļĿ¼/ļС̡ϵͳƵĻŴ豸
        /// ͨԴʼϵͳܵ
        /// </remarks>
        [DllImport("kernel32.dll", SetLastError = true)]
        private static extern IntPtr CreateFile(string lpFileName, uint dwDesiredAccess, uint dwShareMode,
                                                IntPtr lpSecurityAttributes, uint dwCreationDisposition,
                                                uint dwFlagsAndAttributes, IntPtr hTemplateFile);

        /// <summary>
        /// 豸ִָĲ
        /// </summary>
        /// <param name="hDevice">Ҫִв豸</param>
        /// <param name="dwIoControlCode">Win32 API  <b>FSCTL_</b> Ϊǰ׺ĳ 
        /// <b>WinIoCtl.h</b> ļڣִдط <b>SMART_GET_VERSION</b> </param>
        /// <param name="lpInBuffer">ΪָʱĬϵֵ <b>0</b> </param>
        /// <param name="nInBufferSize">뻺ֽ</param>
        /// <param name="lpOutBuffer">һ <b>GetVersionOutParams</b> ʾִк豸顣</param>
        /// <param name="nOutBufferSize">ֽ</param>
        /// <param name="lpBytesReturned">ʵװصֽ</param>
        /// <param name="lpOverlapped">ͬƣһ㲻ʹãĬֵΪ <b>0</b> </param>
        /// <returns>ʾɹʾʧܡ</returns>
        [DllImport("kernel32.dll", SetLastError = true)]
        private static extern int DeviceIoControl(IntPtr hDevice, uint dwIoControlCode, IntPtr lpInBuffer,
                                                  uint nInBufferSize, ref GetVersionOutParams lpOutBuffer,
                                                  uint nOutBufferSize, ref uint lpBytesReturned,
                                                  [Out] IntPtr lpOverlapped);

        /// <summary>
        /// 豸ִָĲ
        /// </summary>
        /// <param name="hDevice">Ҫִв豸</param>
        /// <param name="dwIoControlCode">Win32 API  <b>FSCTL_</b> Ϊǰ׺ĳ 
        /// <b>WinIoCtl.h</b> ļڣִдط <b>SMART_SEND_DRIVE_COMMAND</b>  <b>SMART_RCV_DRIVE_DATA</b> </param>
        /// <param name="lpInBuffer">һ <b>SendCmdInParams</b> ṹϵͳ͵ĲѯҪݽṹ</param>
        /// <param name="nInBufferSize">뻺ֽ</param>
        /// <param name="lpOutBuffer">һ <b>SendCmdOutParams</b> ṹϵͳص豸Ϣݡ</param>
        /// <param name="nOutBufferSize">ֽ</param>
        /// <param name="lpBytesReturned">ʵװصֽ</param>
        /// <param name="lpOverlapped">ͬƣһ㲻ʹãĬֵΪ <b>0</b> </param>
        /// <returns>ʾɹʾʧܡ</returns>
        [DllImport("kernel32.dll", SetLastError = true)]
        private static extern int DeviceIoControl(IntPtr hDevice, uint dwIoControlCode, ref SendCmdInParams lpInBuffer,
                                                  uint nInBufferSize, ref SendCmdOutParams lpOutBuffer,
                                                  uint nOutBufferSize, ref uint lpBytesReturned,
                                                  [Out] IntPtr lpOverlapped);

        #endregion

        #region ṹ

        /// <summary>
        /// 浱ǰ IDE 豸Ӳ̣ӲϢĽṹ
        /// </summary>
        [Serializable]
        public struct HDiskInfo
        {
            /// <summary>
            /// Ӳͺš
            /// </summary>
            public string ModuleNumber;

            /// <summary>
            /// Ӳ̵Ĺ̼汾
            /// </summary>
            public string Firmware;

            /// <summary>
            /// Ӳкš
            /// </summary>
            public string SerialNumber;

            /// <summary>
            /// ӲMΪλ
            /// </summary>
            public uint Capacity;
            
            /// <summary>
            /// 豸СMΪλ
            /// </summary>
            public int BufferSize;
        }

        /// <summary>
        /// ʾʹ <b>DeviceIoControl</b> ʱ淵صӲϢĽṹ
        /// </summary>
        /// <remarks>>ݽṹ <b>WinIoCtl.h</b> ļΪ <b>_GETVERSIONINPARAMS</b> ṹС</remarks>
        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        private struct GetVersionOutParams
        {
            /// <summary>
            /// IDE豸ĶӲ汾
            /// </summary>
            public byte bVersion;

            /// <summary>
            /// IDE豸Ķ޶汾
            /// </summary>
            public byte bRevision;

            /// <summary>
            /// ֵϵͳûʹãʹôݽṹʱΪ <b>0</b> 
            /// </summary>
            public byte bReserved;

            /// <summary>
            /// IDE豸Ķӳ䡣
            /// </summary>
            public byte bIDEDeviceMap;

            /// <summary>
            /// IDE豸Ķݡ
            /// </summary>
            public uint fCapabilities;

            /// <summary>
            /// ݣʹá
            /// </summary>
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
            public uint[] dwReserved; // For future use.
        }

        /// <summary>
        /// һݽṹʾʹ <b>DeviceIoControl</b> ʱ͵ϵͳеݽṹ <b>SendCmdInParams</b> ĳԱṹ
        /// ʾҪȡ豸ܲľ嶨
        /// </summary>
        /// <seealso cref="SendCmdInParams"/>
        /// <remarks>ݽṹ <b>WinIoCtl.h</b> ļΪ <b>_IDEREGS</b> С</remarks>
        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        private struct IdeRegs
        {
            /// <summary>
            /// ͵ϵͳעΪϵͳ <b>SMART Command</b> 
            /// </summary>
            public byte bFeaturesReg;

            /// <summary>
            /// ȡIDE豸
            /// </summary>
            public byte bSectorCountReg;

            /// <summary>
            /// ȡIDE豸š
            /// </summary>
            public byte bSectorNumberReg;

            /// <summary>
            /// ȡIDE豸Ͷֵ
            /// </summary>
            public byte bCylLowReg;

            /// <summary>
            /// ȡIDE豸߶ֵ
            /// </summary>
            public byte bCylHighReg;

            /// <summary>
            /// ȡIDE豸ͷϢ
            /// </summary>
            public byte bDriveHeadReg;

            /// <summary>
            /// ȡIDE豸
            /// </summary>
            public byte bCommandReg;

            /// <summary>
            /// ݣֵӦΪ <b>0</b> 
            /// </summary>
            public byte bReserved;
        }

        /// <summary>
        /// ִ <b>DeviceIoControl</b> ʱϵͳύִв
        /// </summary>
        /// <seealso cref="SendCmdInParams"/>
        /// <remarks>ݽṹ <b>WinIoCtl.h</b> ļΪ <b>_SENDCMDINPARAMS</b> С</remarks>
        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        private struct SendCmdInParams
        {
            /// <summary>
            /// ݻС
            /// </summary>
            public uint cBufferSize;

            /// <summary>
            /// ϵͳ͵Ĵ豸ݽṹ
            /// </summary>
            public IdeRegs irDriveRegs;

            /// <summary>
            /// ϣϵͳƵ̵ıš
            /// </summary>
            public byte bDriveNumber;

            /// <summary>
            /// ݣʹá
            /// </summary>
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 3)]
            public byte[] bReserved;

            /// <summary>
            /// ݣʹá
            /// </summary>
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
            public uint[] dwReserved;

            /// <summary>
            /// 浱ǰ <b>SendCmdInParams</b> ṹݺĴС
            /// </summary>
            public byte bBuffer;
        }

        /// <summary>
        /// ִ <b>DeviceIoControl</b> ϵͳص <b>SendCmdOutParams</b> ṹ
        /// 豸ǰϢݽṹ
        /// </summary>
        /// <seealso cref="SendCmdInParams"/>
        /// <remarks>
        /// ݽṹ <b>WinIoCtl.h</b> ļΪ <b>_DRIVERSTATUS</b> С
        /// <para>
        /// ±<br />
        /// <list type="table">
        /// <listheader>
        /// <term></term>
        /// <description>˵</description>
        /// <item><term>SMART_NO_ERROR = 0</term>
        /// <description>ûд</description></item>
        /// <item><term>SMART_IDE_ERROR = 1</term>
        /// <description>IDE</description></item>
        /// <item><term>SMART_INVALID_FLAG = 2</term>
        /// <description>͵Ч</description></item>
        /// <item><term>SMART_INVALID_COMMAND = 3</term>
        /// <description>͵ĶЧ</description></item>
        /// <item><term>SMART_INVALID_BUFFER = 4</term>
        /// <description>ƻЧΪջЧַ</description></item>
        /// <item><term>SMART_INVALID_DRIVE = 5</term>
        /// <description>Ч</description></item>
        /// <item><term>SMART_INVALID_IOCTL = 6</term>
        /// <description>ЧIOCTL</description></item>
        /// <item><term>SMART_ERROR_NO_MEM =  7</term>
        /// <description>ʹõĻ޷</description></item>
        /// <item><term>SMART_INVALID_REGISTER = 8</term>
        /// <description>IDEעЧ</description></item>
        /// <item><term>SMART_NOT_SUPPORTED = 9</term>
        /// <description>Ч</description></item>
        /// <item><term>SMART_NO_IDE_DEVICE = 10</term>
        /// <description>͵ơ</description></item>
        /// </list>
        /// </para>
        /// </remarks>
        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        private struct DriverStatus
        {
            /// <summary>
            /// IDE豸󣬱Ĵ룬<b>0</b> ʾûд
            /// </summary>
            public byte bDriverError;

            /// <summary>
            /// IDE豸עĴݡ
            /// </summary>
            public byte bIDEStatus;

            /// <summary>
            /// ݣʹá
            /// </summary>
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
            public byte[] bReserved;

            /// <summary>
            /// ݣʹá
            /// </summary>
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
            public uint[] dwReserved;
        }

        /// <summary>
        /// ʾִ <b>DeviceIoControl</b> 󱣴ϵͳݲѯصĴ豸Ϣݽṹ
        /// </summary>
        [StructLayout(LayoutKind.Sequential, Pack = 1)]
        private struct SendCmdOutParams
        {
            /// <summary>
            /// ʾжϢĻС
            /// </summary>
            public uint cBufferSize;

            /// <summary>
            /// ʾѯ豸ĴϢ״̬
            /// </summary>
            public DriverStatus DriverStatus;

            /// <summary>
            /// ʾϵͳص豸ӲϢĶݽṹ
            /// </summary>
            public IdSector bBuffer;
        }

        /// <summary>
        /// ִ <b>DeviceIoControl</b> ϵͳص <b>SendCmdOutParams</b> ṹ
        /// 豸ӲϢݽṹ
        /// </summary>
        /// <seealso cref="SendCmdInParams"/>
        [StructLayout(LayoutKind.Sequential, Pack = 1, Size = 512)]
        private struct IdSector
        {
            /// <summary>
            /// 豸ͨϢ
            /// </summary>
            public ushort wGenConfig;

            /// <summary>
            /// 豸
            /// </summary>
            public ushort wNumCyls;

            /// <summary>
            /// ݣʹá
            /// </summary>
            public ushort wReserved;

            /// <summary>
            /// 豸ĴͷĿ
            /// </summary>
            public ushort wNumHeads;

            /// <summary>
            /// 豸ĴŵĿ
            /// </summary>
            public ushort wBytesPerTrack;

            /// <summary>
            /// 豸Ŀ
            /// </summary>
            public ushort wBytesPerSector;

            /// <summary>
            /// 豸趨ŵĿ
            /// </summary>
            public ushort wSectorsPerTrack;

            /// <summary>
            /// 豸ĳƷơ
            /// </summary>
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 3)]
            public ushort[] wVendorUnique;

            /// <summary>
            /// 豸Ʒ̵ȫΨһ롣
            /// </summary>
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 20)]
            public byte[] sSerialNumber;

            /// <summary>
            /// 豸Ļ͡
            /// </summary>
            public ushort wBufferType;

            /// <summary>
            /// 豸λbyte
            /// </summary>
            public ushort wBufferSize;

            /// <summary>
            /// 豸Ĵ;ECCݵĴС
            /// </summary>
            public ushort wECCSize;

            /// <summary>
            /// 豸Ĺ̼汾
            /// </summary>
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 8)]
            public byte[] sFirmwareRev;

            /// <summary>
            /// 豸ͺš
            /// </summary>
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 40)]
            public byte[] sModelNumber;

            /// <summary>
            /// 豸ƵչݣУ
            /// </summary>
            public ushort wMoreVendorUnique;

            /// <summary>
            /// 豸˫ָģʽ
            /// </summary>
            public ushort wDoubleWordIO;

            /// <summary>
            /// 豸СλByte
            /// </summary>
            public ushort wCapabilities;

            /// <summary>
            /// һݣʹá
            /// </summary>
            public ushort wReserved1;

            /// <summary>
            /// 豸PIOģʽѲʱ䡣
            /// </summary>
            public ushort wPIOTiming;

            /// <summary>
            /// 豸DMA ģʽѲʱ䡣
            /// </summary>
            public ushort wDMATiming;

            /// <summary>
            /// 豸ͣSCSI,IDEȡ
            /// </summary>
            public ushort wBS;

            /// <summary>
            /// 豸ĵǰ
            /// </summary>
            public ushort wNumCurrentCyls;

            /// <summary>
            /// 豸ǰͷ
            /// </summary>
            public ushort wNumCurrentHeads;

            /// <summary>
            /// 豸ĵǰĴŵ
            /// </summary>
            public ushort wNumCurrentSectorsPerTrack;

            /// <summary>
            /// 豸ĵǰλbyte
            /// </summary>
            public uint ulCurrentSectorCapacity;

            /// <summary>
            /// дģʽ֧֡
            /// </summary>
            public ushort wMultSectorStuff;

            /// <summary>
            /// ûǷԶַ(LBAģʽ֧֡
            /// </summary>
            public uint ulTotalAddressableSectors;

            /// <summary>
            /// ָDMAģʽ
            /// </summary>
            public ushort wSingleWordDMA;

            /// <summary>
            /// ָDMAģʽ
            /// </summary>
            public ushort wMultiWordDMA;

            /// <summary>
            /// ݣʹá
            /// </summary>
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 128)]
            public byte[] bReserved;
        }

        /// <summary>
        /// 
        /// </summary>
        [StructLayout(LayoutKind.Sequential)]
        public struct RECT
        {
            /// <summary>
            /// 
            /// </summary>
            /// <param name="left"></param>
            /// <param name="top"></param>
            /// <param name="right"></param>
            /// <param name="bottom"></param>
            public RECT(int left, int top, int right, int bottom)
            {
                this.left = left;
                this.top = top;
                this.right = right;
                this.bottom = bottom;
            }

            /// <summary>
            /// 
            /// </summary>
            /// <param name="r"></param>
            public RECT(Rectangle r)
            {
                left = r.Left;
                top = r.Top;
                right = r.Right;
                bottom = r.Bottom;
            }
            /// <summary>
            /// 
            /// </summary>
            public int left;
            /// <summary>
            /// 
            /// </summary>
            public int top;
            /// <summary>
            /// 
            /// </summary>
            public int right;
            /// <summary>
            /// 
            /// </summary>
            public int bottom;

            /// <summary>
            /// 
            /// </summary>
            /// <param name="x"></param>
            /// <param name="y"></param>
            /// <param name="width"></param>
            /// <param name="height"></param>
            /// <returns></returns>
            public static RECT FromXYWH(int x, int y, int width, int height)
            {
                return new RECT(x, y, x + width, y + height);
            }

            /// <summary>
            /// 
            /// </summary>
            public Size Size
            {
                get { return new Size(right - left, bottom - top); }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        [StructLayout(LayoutKind.Sequential)]
        public sealed class SCROLLINFO
        {
            public SCROLLINFO()
            {
                this.cbSize = Marshal.SizeOf(typeof(SCROLLINFO));
            }

            public SCROLLINFO(int mask, int min, int max, int page, int pos)
            {
                this.cbSize = Marshal.SizeOf(typeof(SCROLLINFO));
                this.fMask = mask;
                this.nMin = min;
                this.nMax = max;
                this.nPage = page;
                this.nPos = pos;
            }

            public int cbSize;
            public int fMask;
            public int nMin;
            public int nMax;
            public int nPage;
            public int nPos;
            public int nTrackPos;
        }
        #endregion

        #region 

        /// <summary>
        /// Win32 API ָʾʹ <see cref="RemoveMenu"/> ʱָʹʹID
        /// </summary>
        private const int MF_BYPOSITION = 0x00000400;
        private const uint FILE_SHARE_READ = 0x00000001;
        private const uint FILE_SHARE_WRITE = 0x00000002;
        private const uint FILE_SHARE_DELETE = 0x00000004;
        private const uint SMART_GET_VERSION = 0x00074080; // SMART_GET_VERSION
        private const uint SMART_SEND_DRIVE_COMMAND = 0x0007c084; // SMART_SEND_DRIVE_COMMAND
        private const uint SMART_RCV_DRIVE_DATA = 0x0007c088; // SMART_RCV_DRIVE_DATA
        private const uint GENERIC_READ = 0x80000000;
        private const uint GENERIC_WRITE = 0x40000000;
        private const uint CREATE_NEW = 1;
        private const uint OPEN_EXISTING = 3;
        private const uint BUFFER_SIZE = 512;
        private static readonly Platform currentOs;

        #endregion
    }
}