using System;
using System.Globalization;
using System.Threading;

namespace Core.Systems
{
    public class CultureInfoUtil
    {
        /// <summary>
        /// ʼԻ
        /// </summary>
        public static void InitializeCulture()
        {
            string language = LoadLanguage();

            if (!string.IsNullOrEmpty(language))
            {
                CultureInfo culture = new CultureInfo(language);
                Thread.CurrentThread.CurrentCulture = culture;
                Thread.CurrentThread.CurrentUICulture = culture;
            }
        }

        public static string LoadLanguage()
        {
            const string key = "language";
            string language = RegistryHelper.GetValue(key);

            if (string.IsNullOrEmpty(language))
            {
                //ûδԣǰϵͳΪģôʾģʾӢ
                if (Thread.CurrentThread.CurrentCulture.Name.IndexOf("CN", StringComparison.OrdinalIgnoreCase) >= 0)
                {
                    language = "zh-CN";
                }
                else
                {
                    language = "en-US"; //ĬΪӢ
                }
            }
            return language;
        }

        /// <summary>
        /// RegionϢģ:
        ///       Name:                            CN
        ///       DisplayName:                     л񹲺͹
        ///       EnglishName:                     People's Republic of China
        ///       IsMetric:                        True
        ///       ThreeLetterISORegionName:        CHN
        ///       ThreeLetterWindowsRegionName: CHN
        ///       TwoLetterISORegionName:          CN
        ///       CurrencySymbol:                  
        ///       ISOCurrencySymbol:               CNY
        /// </summary>
        public static RegionInfo CurrentRegion
        {
            get
            {
                return RegionInfo.CurrentRegion;
            }
        }
    }
}
