using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.Specialized;
using System.Collections.ObjectModel;

namespace Core.Web.CacheManage
{
    /// <summary>
    /// ӿ
    /// </summary>
    public interface ICache
    {
        /// <summary>
        /// ȡһֵ,ָʾǰĻǷ
        /// </summary>
        bool EnableCache
        {
            get;
        }

        /// <summary>
        /// ȡ
        /// </summary>
        CacheType Type
        {
            get;
        }

        /// <summary>
        /// 黺Ƿָļ
        /// </summary>
        /// <param name="key">Ҫļ</param>
        /// <returns>һֵ,ָʾļǷ</returns>
        bool Contains(string key);


        /// <summary>
        /// ϵͳǷָĻ
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="key">key</param>
        /// <returns>͵ֵǷ</returns>
        bool Contains<T>(string key);


        /// <summary>
        /// ӻлȡֵָ
        /// </summary>
        /// <param name="key">Ҫȡļ</param>
        /// <returns>ֵָ</returns>
        T Get<T>(string key);

        /// <summary>
        /// ȡмֵ
        /// </summary>
        int Count
        {
            get;
        }

        /// <summary>
        /// ӻ
        /// </summary>
        /// <param name="key">ؼ</param>
        /// <param name="value">ֵ</param>
        /// <returns>ӵļֵ</returns>
        void Add<T>(string key, T value);

        /// <summary>
        /// ӻ
        /// </summary>
        /// <param name="key">ؼ</param>
        /// <param name="value">ֵ</param>
        /// <param name="absoluteExpiration">ʱ</param>
        /// <returns>ӵļֵ</returns>
        void Add<T>(string key, T value, DateTime absoluteExpiration);

        /// <summary>
        /// ӻ
        /// </summary>
        /// <param name="key">ؼ</param>
        /// <param name="value">ֵ</param>
        /// <param name="slidingExpiration">ʱ</param>
        /// <returns>ӵļֵ</returns>
        void Add<T>(string key, T value, TimeSpan slidingExpiration);

        /// <summary>
        /// ӻ
        /// </summary>
        /// <param name="key">ؼ</param>
        /// <param name="value">ֵ</param>
        /// <param name="minutes">ʱ()</param>
        /// <returns>ӵļֵ</returns>
        void Add<T>(string key, T value, int minutes);

        /// <summary>
        /// ӻ
        /// </summary>
        /// <param name="key">ؼ</param>
        /// <param name="value">ֵ</param>
        /// <param name="priority">ȼ</param>
        /// <param name="slidingExpiration">ʱ</param>
        void Add<T>(string key, T value, CachePriority priority, TimeSpan slidingExpiration);

        /// <summary>
        /// ӻ
        /// </summary>
        /// <param name="key">ؼ</param>
        /// <param name="value">ֵ</param>
        /// <param name="priority">ȼ</param>
        /// <param name="absoluteExpiration">ʱ</param>
        void Add<T>(string key, T value, CachePriority priority, DateTime absoluteExpiration);


        /// <summary>
        /// ԷָĻ
        /// </summary>
        /// <typeparam name="T">ݵ</typeparam>
        /// <param name="key">key</param>
        /// <param name="value"></param>
        /// <returns>Ƿ</returns>
        bool TryGetValue<T>(string key, out T value);

       


        /// <summary>
        /// ƳĳؼֵĻ沢Ӧֵ
        /// </summary>
        /// <param name="key">ؼ</param>
        void Remove(string key);

        /// <summary>
        /// ƳдĳؼֵĻ
        /// </summary>
        /// <param name="key">ؼ</param>
        /// <returns>رƳ</returns>
        int RemoveContains(string key);

        /// <summary>
        /// ƳĳؼֿͷĻ
        /// </summary>
        /// <param name="key">ؼ</param>
        /// <returns>رƳ</returns>
        int RemoveStartWith(string key);

        /// <summary>
        /// ƳĳؼֽβĻ
        /// </summary>
        /// <param name="key">ؼ</param>
        /// <returns>رƳ</returns>
        int RemoveEndWith(string key);

        /// <summary>
        /// ƳеĻ
        /// </summary>
        /// <returns>رƳ</returns>
        int Clear();

        /// <summary>
        /// еļб
        /// </summary>
        ReadOnlyCollection<string> Keys
        {
            get;
        }
    }

    /// <summary>
    /// ȼ
    /// </summary>
    public enum CachePriority
    {
        /// <summary>
        /// 
        /// </summary>
        None = 0,

        /// <summary>
        /// 
        /// </summary>
        Low = 1,

        /// <summary>
        /// ͨ
        /// </summary>
        Normal = 2,

        /// <summary>
        /// 
        /// </summary>
        High = 3,

        /// <summary>
        /// ܱɾ
        /// </summary>
        NotRemovable = 4,
    }
}

